{ (c) Copyright 1995,1997 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit ALExpr;
{$B-,F+,A+,N+,R-,S-,V-,I-,G+,X+,T-}

Interface
Uses Calcer,Def2x2,ExprComp,TPInline,Diffy;

Type

 {  ./ப ࠦ }
 PArithExpr=^TArithExpr;
 TArithExpr=object(TExprCompilator) 
  Expr:TExpression;
  ExprCalcer:PCalcer;
  IsArith:boolean;
  constructor Init(Data:string);
  procedure GetDataString(Var S:string);virtual;
  procedure Translate;virtual;
  function Calculate:PFloat;virtual;
  procedure Compile;
  destructor Done; virtual;
 end;

 {  ᪨ ࠦ }
 PLogicExpr=^TLogicExpr;
 TLogicExpr=object(TArithExpr)
  LTree:PLogicTree;
  procedure Translate;virtual;
  function CalculateB:boolean;virtual;
  procedure Compile;
 end;

Implementation

constructor TArithExpr.Init(Data:string);
begin
 Inherited Init;
 DataStr:=Data
end;

procedure TArithExpr.GetDataString(Var S:string);
begin
 If CurY<2 then S:=DataStr else EOFData:=True
end;

procedure TArithExpr.Translate;
begin
 SetJump(JumpPoint);
 If TransError=0 then begin
  GetTerm;
  IsArith:=True;
  Case TopTerm^.TermType of
   opStrArrVar,opStringConst..opSConst,opParStrFunc,opStringFunc,opDirectStrFunc,
   opRefString,opRefStrArrVar:begin
    TranslateString(Expr);
    IsArith:=False
   end;
   else TranslateMath(Expr,True);
  end;
  If TopTerm^.TermType<>opEndData then EJump0(teEIE);
  Compile;
 end
 else begin
  If TransError=teEndExpected then TransError:=teEIE;
 end;
 DisposeMemTmp;
end;

procedure TArithExpr.Compile;
begin
 CompError.Error:=0;
 Mask8087(False);
 If IsArith then ExprCalcer:=New(PExpressionCalcer, Init(Expr))
 else ExprCalcer:=New(PStrExpressionCalcer, Init(Expr));
 Mask8087(True);
 If CompError.Error<>0 then begin
  TransError:=CompError.Error;
  ErrorX:=CompError.cX; ErrorY:=CompError.cY
 end
end;

function TArithExpr.Calculate:PFloat;
begin
 Mask8087(False);
 Calculate:=ExprCalcer^.Calculate;
 Mask8087(True)
end;

destructor TArithExpr.Done;
begin
 If ExprCalcer<>nil then Dispose(ExprCalcer, Done);
 Inherited Done;
end;

procedure TLogicExpr.Translate;
begin
 SetJump(JumpPoint);
 If TransError=0 then begin
  GetTerm;
  NLogCalcs:=0;
  LTree:=TranslateLogic(False,False);
  If TopTerm^.TermType<>opEndData then EJump0(teEIE);
  Compile;
 end
 else begin
  If TransError=teEndExpected then TransError:=teEIE;
 end;
 DisposeMemTmp;
end;

procedure TLogicExpr.Compile;
begin
 CompError.Error:=0;
 Mask8087(False);
 ExprCalcer:=New(PLogicCalcer, Init(NLogCalcs,LTree));
 Mask8087(True);
 If CompError.Error<>0 then begin
  TransError:=CompError.Error;
  ErrorX:=CompError.cX; ErrorY:=CompError.cY
 end
end;

function TLogicExpr.CalculateB:boolean;
begin
 Mask8087(False);
 CalculateB:=PLogicCalcer(ExprCalcer)^.CalculateB;
 Mask8087(True)
end;

End.
