Unit Diffy;
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface

Procedure FastMove(Var Source,Dest; Len:word);
Procedure FastMoveWord(Var Source,Dest; Len:word);
Procedure FillWord(Var Dest; Len,What:word);
Procedure FillPatt(Var Dest,Patt; Count,Len:word);
Procedure MoveTail(Var Source,Dest; Len:word);
Function MinI(A,B:integer):integer;
Function MaxI(A,B:integer):integer;

Function Div10(B:byte):byte;
Inline($58/ $D4/$0A/ $8A/$C4); { pop ax; aam; mov al,ah }

Function Mod10(B:byte):byte;
Inline($58/ $D4/$0A); { pop ax; aam }

Function Gtexp(V:extended; Var E:integer):extended;
Function Chexp(V:extended; E:integer):extended;
Function NotNumber(Var N:extended):boolean;
Procedure Mask8087(Mask:boolean);

{ ८ࠧ ஫   }
function CalcSiphKey(const Psp:string):word;
{ ஥ ⮥ ஢ 箬 Key, .  . ப
  ஫  . CalcSiphKey }
procedure Sipher(Var Buf; Len:integer; Key:word);

Implementation

Procedure FastMove(Var Source,Dest; Len:word);assembler;
asm
 push ds
 lds si,Source
 les di,Dest
 mov cx,Len
 jcxz @1
 cld
 rep movsb
@1:
 pop ds
End;

Procedure FastMoveWord(Var Source,Dest; Len:word);assembler;
asm
 PUSH DS
 LDS SI,Source
 LES DI,Dest
 MOV CX,Len
 JCXZ @1
 CLD
 REP MOVSW
@1:
 POP DS
End;

Procedure FillWord(Var Dest; Len,What:word);assembler;
asm
 les di,Dest
 mov cx,Len
 mov ax,What
 cld
 rep stosw
End;

Procedure FillPatt(Var Dest,Patt; Count,Len:word);assembler;
asm
 mov cx,Len
 jcxz @out
 xchg cx,dx
 mov cx,Count
 jcxz @out
 push ds
 les di,Dest
 lds si,Patt
 mov bx,si
 cld
@1:
 push cx
 mov cx,dx
 mov si,bx
 rep movsb
 pop cx
 loop @1
 pop ds
@out:
End;

Function NotNumber(Var N:extended):boolean;assembler;
asm
 xor ax,ax
 les di,N
 mov bx,es:[di+8]
 and bx,0111111111111111b
 cmp bx,0111111111111111b
 jne @out
 inc al
@Out:
End;

Var Old87Mask:word;

(*
Procedure Mask8087(Mask:boolean);assembler;
Var D:word;
asm
 mov al,Mask
 or al,al
 je @1        { ᪨஢ }
 mov D,0372h
 jmp @2
@1:
 fstcw D
 fwait
 or D,00ffh
@2:
 fldcw D
 fwait
end;
*)

Procedure Mask8087(Mask:boolean);assembler;
Var S:word;
asm
 mov al,Mask
(* cmp Test8087,0
 jne @2

 or al,al
 je @1        { ᪨஢ }

 fclex
 fldcw Old87Mask
 fwait
 jmp @out

@1:
 mov S,$7F3F
 fstcw Old87Mask
 fclex
 fldcw S
 fwait
 jmp @out *)

@2:
 or al,al
 je @3
 mov s,0372h
 jmp @4
@3:
 {fwait}
 fstcw word ptr s
 or s,00ffh
@4:
 fclex
 fldcw word ptr s
@out:
End;

Procedure MoveTail(Var Source,Dest; Len:word);assembler;
asm
 push ds
 lds si,Source
 les di,Dest
 mov cx,Len
 jcxz @1
 add si,cx
 dec si
 add di,cx
 dec di
 std
 rep movsb
@1:
 pop ds
End;

Function MaxI(A,B:integer):integer;assembler;
asm
 mov ax,A
 cmp ax,B
 jge @no
 mov ax,B
@no:
end;

Function MinI(A,B:integer):integer;assembler;
asm
 mov ax,A
 cmp ax,B
 jle @no
 mov ax,B
@no:
end;

Function Gtexp(V:extended; Var E:integer):extended;assembler;
{Var VW:array[1..5] of integer absolute V;
Begin
 E:=VW[5] and $7FFF;
 Dec(E,16383);
 VW[5]:=VW[5] and $8000;
 VW[5]:=VW[5] or 16383;
 Gtexp:=V
}
asm
 mov ax,word ptr V[8]
 mov bx,ax
 and ax,7fffh
 or ax,ax
 je @1
 sub ax,16383
@1:
 les di,E
 mov es:[di],ax
 je @2
 and bx,8000h
 or bx,16383
 mov word ptr V[8],bx
@2:
 fld tbyte ptr V
 fwait
End;

Const Zero:word=0;

Function Chexp(V:extended; E:integer):extended;assembler;
{Var VW:array[1..5] of integer absolute V;
Begin
 If V<>0 then Inc(VW[5],E);
 Chexp:=V
}
asm
 fld tbyte ptr V
 fcomp dword ptr Zero
 fstsw ax
 fwait
 sahf
 je @1
 mov ax,E
 add word ptr V[8],ax
@1:
 fld tbyte ptr V
End;

function CalcSiphKey(const Psp:string):word;assembler;
{ ८ࠧ ஫   }
asm
 push ds
 lds si,Psp
 cld
 xor dx,dx
 mov ax,dx
 lodsb
 mov cx,ax {  cx -  ப ஫ }
 jcxz @exit
@1:
 lodsb
 xor ah,ah { 頥 訩  }
 shl dx,3
 add dx,ax
 loop @1
 mov ax,dx
@exit:
 pop ds
end;

{ ஥ ⮥ ஢ 箬 Key, .  . ப
  ஫  . CalcSiphKey }
procedure Sipher(Var Buf; Len:integer; Key:word);assembler;
asm
 mov dx,Key
 mov cx,Len
 jcxz @exit
 push ds
 les di,Buf
 lds si,Buf
 mov bx,17257  { ⥫ }
 { 㥬 }
@1:
 mov ax,dx    { ah -  祢  }
 mul bx
 add ax,21545
 mov dx,ax
 lodsb         {   }
 xor al,ah     { ८ࠧ㥬   }
 stosb         { ࠭塞 }
 loop @1
 pop ds
@exit:
end;

End.
