Unit MyTV;

Interface

Uses App,Views,Dialogs,Drivers,Objects,Validate;

Const
 PrintMargin:byte=0;
 PrinterControl:string[20]='';

 IconWidth=8;
 IconHeight=3;
 cmInsertIcon=50000;
 cmDeleteIcon=50001;
 cmMinimize  =50002;

Type

PDemoDialog = ^TDemoDialog;
TDemoDialog = object(TDialog)
 IsTile:boolean;
 constructor Init(Bounds:TRect; ATitle:string);
 procedure HandleEvent(Var Event:TEvent);virtual;
 function IsActive:boolean;
end;

PMyCheckBoxes=^TMyCheckBoxes;
TMyCheckBoxes=object(TCheckBoxes)
  Procedure HandleEvent(Var Event:TEvent);virtual;
end;

PMyRadioButtons=^TMyRadioButtons;
TMyRadioButtons=object(TRadioButtons)
 Procedure HandleEvent(Var Event:TEvent);virtual;
end;

PProcent=^TProcent;
TProcent=object(TView)
 All:word;
 K:real;
 Nqu:byte;
 Color:byte;
 CurStep:word;
 constructor Init(Bounds:TRect; ASize:word; AColor:byte);
 procedure Draw;virtual;
 procedure Update(Step:word);
end;

PIcon=^TIcon;
TIcon=object(TView)
 Title:string;
 OwnerWin:PView;
 constructor Init(R:TRect);
 procedure Draw;virtual;
 procedure HandleEvent(Var Event:TEvent);virtual;
end;

PIcDeskTop=^TIcDeskTop;
TIcDeskTop=object(TDeskTop)
 IconX:integer;
 IconColl:PCollection;
 constructor Init(R:TRect);
 procedure HandleEvent(Var Event:TEvent);virtual;
 function InsertIcon(Icon:PView):boolean;
 procedure DeleteIcon(Icon:PView);
end;

PIcWindow=^TIcWindow;
TIcWindow=object(TWindow)
 EnableIconize:boolean;
 constructor Init(Var Bounds:TRect; ATitle:TTitleStr; ANumber:integer);
 procedure HandleEvent(Var Event:TEvent);virtual;
 function GetIconName:string;virtual;
 procedure Minimize;
end;

PVError=^TVError;
TVError=object(TView)
 Need:boolean;
 ErrorSt:string[80];
 constructor Init(Bounds:TRect; S:string);
 procedure Draw;virtual;
 procedure HandleEvent(Var Event:TEvent);virtual;
end;

Implementation
Uses MyString,MsgBox,Dos;

Constructor TDemoDialog.Init(Bounds:TRect; ATitle:string);
Begin
 TDialog.Init(Bounds, ATitle);
 EventMask:=EventMask or evBroadcast;
 Options:=Options or ofTileable
End;

Function TDemoDialog.IsActive:boolean;
Var B:boolean;
Begin
 B:=State and (sfActive+sfSelected)<>0;
 If not B then MessageBox(^C'  ⨢!',nil,mfOKButton);
 IsActive:=B
End;

Procedure TDemoDialog.HandleEvent(Var Event:TEvent);
Begin
   TDialog.HandleEvent(event);
   If event.what=evkeydown then begin
    If phase=phPostProcess then begin
     Case event.keycode of
      kbleft,kbup:
       begin
        ClearEvent(Event);
        SelectNext(True); exit end;
      kbdown,kbright:
       begin
        ClearEvent(Event);
        If Current^.Valid(cmNext) then SelectNext(False); exit end;
      else exit
     end;
    end;
   end
End;

Constructor TProcent.Init(Bounds:TRect; ASize:word; AColor:byte);
Begin
 TView.Init(Bounds);
 Options:=Options and not ofSelectable;
 All:=ASize;
 Nqu:=Size.X;
 Color:=AColor;
 K:=Nqu/100;
 CurStep:=0;
End;

Procedure TProcent.Draw;
Var Procent:double; B:TDrawBuffer; CurQ:byte;St:string[5];
Begin
 MoveChar(B,#176,Color,Size.X);
 Procent:=100/All;
 Procent:=Procent*CurStep;
 CurQ:=Round(K*Procent);
 MoveChar(B,#219,Color,CurQ);
 WriteLine(0,0,Size.X,1,B);
 Str(Round(Procent):3,St);
 MoveStr(B,DupStr(' ',Size.X-4)+St+'%',$74);
 WriteLine(0,1,Size.X,1,B);
End;

Procedure TProcent.Update(Step:word);
Begin
 CurStep:=Step;
 DrawView
End;

Procedure TMyCheckBoxes.HandleEvent(Var Event:TEvent);
Begin
  If event.what=evkeydown then begin
    Case event.keycode of
     kbleft:
       If State and sfFocused <>0 then
        begin
           ClearEvent(Event);
           Owner^.SelectNext(True); exit
        end;

     kbright:
       If State and sfFocused <>0 then begin
        ClearEvent(Event);
        Owner^.SelectNext(False); exit
       end;
    end;

  end;
  TCheckBoxes.HandleEvent(event);
end;

Procedure TMyRadioButtons.HandleEvent(Var Event:TEvent);
Begin
  If event.what=evkeydown then begin
    Case event.keycode of
     kbleft:
       If State and sfFocused <>0 then
        begin
           ClearEvent(Event);
           Owner^.SelectNext(True); exit
        end;

     kbright:
       If State and sfFocused <>0 then begin
        ClearEvent(Event);
        Owner^.SelectNext(False); exit
       end;
    end;

  end;
  TRadioButtons.HandleEvent(event);
end;

Constructor TIcon.Init(R:TRect);
Begin
 Inherited Init(R);
 Options:=Options and not ofTopSelect;
End;

Procedure TIcon.Draw;
Var Buf:TDrawBuffer; Color:word;
Begin
 Color:=$30;
 MoveChar(Buf,' ',Color,IconHeight*IconWidth);
 MoveBuf(Buf,Title[1],Color,Length(Title));
 WriteBuf(0,0,IconWidth,IconHeight,Buf)
End;

Procedure TIcon.HandleEvent(Var Event:TEvent);
Begin
 If (Event.What=evMouseDown) and Event.Double then
  Message(DeskTop,evCommand,cmDeleteIcon,@Self)
End;

Constructor TIcDeskTop.Init(R:TRect);
Begin
 Inherited Init(R);
 IconX:=0;
 New(IconColl, Init(5,5))
End;

Procedure TIcDeskTop.HandleEvent(Var Event:TEvent);
Type Ppointer=^pointer;
Begin
 Inherited HandleEvent(Event);
 If Event.What=evCommand then begin
  Case Event.Command of
   cmInsertIcon:
    If not InsertIcon(PView(Event.InfoPtr)) then exit;
   cmDeleteIcon: DeleteIcon(Event.InfoPtr);
   else exit
  end;
  ClearEvent(Event)
 end
End;

Function TIcDeskTop.InsertIcon(Icon:PView):boolean;
Begin
 If IconX>Size.X-IconWidth then begin
  InsertIcon:=False; exit
 end;
 InsertBefore(Icon,Last);
 Icon^.MoveTo(IconX,Size.Y-IconHeight);
 IconColl^.Insert(Icon);
 Inc(IconX,IconWidth+1);
 DrawView;
End;

Procedure TIcDeskTop.DeleteIcon(Icon:PView);
Var Ind,I:integer; Ic:PView; P:TPoint;
Begin
 Ind:=IconColl^.IndexOf(Icon);
 If Ind=-1 then exit;
 Ic:=IconColl^.At(Ind);
 PIcon(Ic)^.OwnerWin^.Show;
 IconColl^.Free(Icon);
 If IconColl^.Count>0 then
  For I:=Ind to IconColl^.Count-1 do begin
   Ic:=PView(IconColl^.At(I));
   P:=Ic^.Origin;
   Dec(P.X,IconWidth+1);
   Ic^.MoveTo(P.X,P.Y);
  end;
 Dec(IconX,IconWidth+1);
End;

Constructor TIcWindow.Init(Var Bounds:TRect; ATitle:TTitleStr;
 ANumber:integer);
Begin
 Inherited Init(Bounds,ATitle,ANumber);
 EnableIconize:=True
End;

Procedure TIcWindow.HandleEvent(Var Event:TEvent);
Begin
 Inherited HandleEvent(Event);
 If (Event.What=evCommand) and (Event.Command=cmMinimize) then begin
  If EnableIconize and (State and sfModal=0) then Minimize;
  ClearEvent(Event)
 end
End;

Procedure TIcWindow.Minimize;
Var R:TRect; Icon:PIcon;
Begin
 R.Assign(0,0,IconWidth,IconHeight);
 New(Icon,Init(R));
 Icon^.Title:=GetIconName;
 Icon^.OwnerWin:=@Self;
 If Message(DeskTop,evCommand,cmInsertIcon,Icon)<>nil then Hide;
End;

Function TIcWindow.GetIconName:string;
Begin
 GetIconName:=''
End;

Constructor TVError.Init(Bounds:TRect; S:string);
Begin
 Inherited Init(Bounds);
 ErrorSt:=S;
 Options:=(Options or ofPreProcess) and not ofSelectable;
 GrowMode:=GrowMode or gfGrowHiX;
 EventMask:=evMouse or evKeyboard;
 Need:=True
End;

Procedure TVError.Draw;
Var B:TDrawBuffer;
Begin
 MoveChar(B,' ',$4E,Size.X);
 MoveStr(B,ErrorSt,$4E);
 WriteLine(0,0,Size.X,1,B)
End;

Procedure TVError.HandleEvent(Var Event:TEvent);
Begin
 If Need then begin
  Hide;
  Need:=False
 end
End;

End.
